package com.ejie.ab79.dao.inspecciones;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.inspecciones.DesResIns;
import com.ejie.ab79.model.inspecciones.OrigenesInspeccion;
import com.ejie.ab79.model.inspecciones.ResultadosInspeccion;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ResultadosInspeccionDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class ResultadosInspeccionDaoImpl implements ResultadosInspeccionDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDRESULTADOINSPECCION",
			"RESULDESCRIPCIONCASTELLANO", "RESULDESCRIPCIONEUSKERA", "FECHAREGISTRO", "USUARIOREGISTRO", "IDORIGEN",
			"IDDIRECCION", "DESNEUSORIGEN", "DESNESORIGEN", "DESNEUSDIREC", "DESNESDIREC" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<ResultadosInspeccion> rwMap = new RowMapper<ResultadosInspeccion>() {
		public ResultadosInspeccion mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			ResultadosInspeccion resultadoInspeccion = new ResultadosInspeccion();
			resultadoInspeccion.setIdResultadoInspeccion(resultSet.getInt("IDRESULTADOINSPECCION"));
			resultadoInspeccion.setBaja(resultSet.getInt("BAJA"));
			resultadoInspeccion.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			resultadoInspeccion.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));

			DesResIns desResIns = new DesResIns();
			desResIns.setIdDesResIns(resultSet.getLong("IDDESRESINS"));
			desResIns.setDescripcionCastellano(resultSet.getString("RESULDESCRIPCIONCASTELLANO"));
			desResIns.setDescripcionEuskera(resultSet.getString("RESULDESCRIPCIONEUSKERA"));
			resultadoInspeccion.setDesResIns(desResIns);

			return resultadoInspeccion;
		}
	};

	private RowMapper<ResultadosInspeccion> rwMapFindAll = new RowMapper<ResultadosInspeccion>() {
		public ResultadosInspeccion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			ResultadosInspeccion resultadosInspeccion = new ResultadosInspeccion();

			resultadosInspeccion.setIdResultadoInspeccion(resultSet.getInt("IDRESULTADOINSPECCION"));
			resultadosInspeccion.setBaja(resultSet.getInt("BAJA"));
			resultadosInspeccion.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			resultadosInspeccion.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));

			Direcciones direccion = new Direcciones();
			direccion.setIdDireccion(resultSet.getInt("IDDIRECCION"));
			direccion.setDescripcionCastellano(resultSet.getString("DESNESDIREC"));
			direccion.setDescripcionEuskera(resultSet.getString("DESNEUSDIREC"));
			resultadosInspeccion.setDireccion(direccion);

			OrigenesInspeccion origenesInspeccion = new OrigenesInspeccion();
			origenesInspeccion.setIdOrigenInspeccion(resultSet.getInt("IDORIGEN"));
			origenesInspeccion.setDescripcionCastellano(resultSet.getString("DESNESORIGEN"));
			origenesInspeccion.setDescripcionEuskera(resultSet.getString("DESNEUSORIGEN"));
			resultadosInspeccion.setOrigenInspeccion(origenesInspeccion);

			DesResIns desResIns = new DesResIns();
			desResIns.setIdDesResIns(resultSet.getLong("IDDESRESINS"));
			desResIns.setDescripcionCastellano(resultSet.getString("RESULDESCRIPCIONCASTELLANO"));
			desResIns.setDescripcionEuskera(resultSet.getString("RESULDESCRIPCIONEUSKERA"));
			resultadosInspeccion.setDesResIns(desResIns);

			return resultadosInspeccion;
		}
	};

	private RowMapper<ResultadosInspeccion> rwMapPK = new RowMapper<ResultadosInspeccion>() {
		public ResultadosInspeccion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new ResultadosInspeccion(resultSet.getInt("IDRESULTADOINSPECCION"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<ResultadosInspeccion>> rwMapJerarquia = new RowMapper<JerarquiaDto<ResultadosInspeccion>>() {
		public JerarquiaDto<ResultadosInspeccion> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			ResultadosInspeccion resultadosinspeccion = new ResultadosInspeccion(
					resultSet.getInt("IDRESULTADOINSPECCION"), resultSet.getDate("FECHAREGISTRO"),
					resultSet.getString("USUARIOREGISTRO"));

			JerarquiaDto<ResultadosInspeccion> jerarquia = new JerarquiaDto<ResultadosInspeccion>();
			jerarquia.setModel(resultadosinspeccion);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the ResultadosInspeccion table.
	 *
	 * @param resultadosinspeccion
	 *            ResultadosInspeccion
	 * @return ResultadosInspeccion
	 */
	public ResultadosInspeccion add(ResultadosInspeccion resultadosinspeccion) {

		int idResultadoInspeccion = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7905T00.NEXTVAL FROM DUAL",
				Integer.class);

		String query = "INSERT INTO RESULTADOS_INSPECCION (ID_RESULTADO_INSPECCION, BAJA, FECHA_REGISTRO, USUARIO_REGISTRO, ID_DIRECCION, ID_ORIGEN_INSPECCION, ID_DES_RES_INS) VALUES (?,?,SYSDATE,?,?,?,?)";
		this.jdbcTemplate.update(query, idResultadoInspeccion, Constantes.BAJA_NO,
				resultadosinspeccion.getUsuarioRegistro(), resultadosinspeccion.getDireccion().getIdDireccion(),
				resultadosinspeccion.getOrigenInspeccion().getIdOrigenInspeccion(),
				resultadosinspeccion.getDesResIns().getIdDesResIns());
		return resultadosinspeccion;
	}

	/**
	 * Updates a single row in the ResultadosInspeccion table.
	 *
	 * @param resultadosinspeccion
	 *            ResultadosInspeccion
	 * @return ResultadosInspeccion
	 */
	public ResultadosInspeccion update(ResultadosInspeccion resultadosinspeccion) {
		String query = "UPDATE RESULTADOS_INSPECCION SET ID_DIRECCION=?, ID_ORIGEN_INSPECCION=?, ID_DES_RES_INS=?,FECHA_ULTMODIFICACION=SYSDATE,USUARIO_ULTMODIFICACION=? WHERE ID_RESULTADO_INSPECCION=?";
		this.jdbcTemplate.update(query, resultadosinspeccion.getDireccion().getIdDireccion(),
				resultadosinspeccion.getOrigenInspeccion().getIdOrigenInspeccion(),
				resultadosinspeccion.getDesResIns().getIdDesResIns(),
				resultadosinspeccion.getUsuarioUltimaModificacion(), resultadosinspeccion.getIdResultadoInspeccion());
		return resultadosinspeccion;
	}

	/**
	 * Finds a single row in the ResultadosInspeccion table.
	 *
	 * @param resultadosinspeccion
	 *            ResultadosInspeccion
	 * @return ResultadosInspeccion
	 */
	@Transactional(readOnly = true)
	public ResultadosInspeccion find(ResultadosInspeccion resultadosinspeccion) {
		String query = "SELECT t1.ID_RESULTADO_INSPECCION IDRESULTADOINSPECCION, t1.BAJA BAJA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t2.ID_ORIGEN_INSPECCION IDORIGEN, t2.DESCRIPCION_CASTELLANO DESNESDIREC,t2.DESCRIPCION_EUSKERA DESNEUSDIREC, t3.ID_DIRECCION IDDIRECCION, t3.DESCRIPCION_EUSKERA DESNEUSORIGEN, t3.DESCRIPCION_CASTELLANO DESNESORIGEN, t4.ID_DES_RES_INS IDDESRESINS, t4.DESCRIPCION_CASTELLANO RESULDESCRIPCIONCASTELLANO, t4.DESCRIPCION_EUSKERA RESULDESCRIPCIONEUSKERA FROM RESULTADOS_INSPECCION t1, ORIGENES_INSPECCION t2, DIRECCIONES t3, DES_RES_INS t4 WHERE t1.ID_RESULTADO_INSPECCION = ? AND (t1.BAJA = 0 OR t1.BAJA IS NULL) AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION AND t1.ID_DES_RES_INS = t4.ID_DES_RES_INS ";

		List<ResultadosInspeccion> resultadosinspeccionList = this.jdbcTemplate.query(query, this.rwMapFindAll,
				resultadosinspeccion.getIdResultadoInspeccion());
		return DataAccessUtils.uniqueResult(resultadosinspeccionList);
	}

	@Override
	public List<ResultadosInspeccion> findByDesResIns(DesResIns desResIns) {
		String query = "SELECT t1.ID_RESULTADO_INSPECCION IDRESULTADOINSPECCION FROM RESULTADOS_INSPECCION t1 WHERE t1.ID_DES_RES_INS = ? ";

		return this.jdbcTemplate.query(query, this.rwMapPK, desResIns.getIdDesResIns());
	}

	@Override
	public Integer findRegistroDuplicado(ResultadosInspeccion resultadoInspeccion) {
		String query = "SELECT COUNT(1) FROM RESULTADOS_INSPECCION t1, ORIGENES_INSPECCION t2, DIRECCIONES t3, DES_RES_INS t4 WHERE t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION AND t1.ID_DES_RES_INS = t4.ID_DES_RES_INS AND t2.ID_ORIGEN_INSPECCION = ? AND t3.ID_DIRECCION = ? AND t4.ID_DES_RES_INS = ? AND t1.BAJA = ?";
		List<Object> params = new ArrayList<Object>();
		params.add(resultadoInspeccion.getOrigenInspeccion().getIdOrigenInspeccion());
		params.add(resultadoInspeccion.getDireccion().getIdDireccion());
		params.add(resultadoInspeccion.getDesResIns().getIdDesResIns());
		params.add(Constantes.BAJA_NO);
		return this.jdbcTemplate.queryForObject(query, params.toArray(), Integer.class); 
	}

	/**
	 * Removes a single row in the ResultadosInspeccion table.
	 *
	 * @param resultadosinspeccion
	 *            ResultadosInspeccion
	 * @return
	 */
	public void remove(ResultadosInspeccion resultadosinspeccion) {
		String query = "UPDATE RESULTADOS_INSPECCION SET BAJA=?, FECHA_ULTMODIFICACION=SYSDATE, USUARIO_ULTMODIFICACION=? WHERE ID_RESULTADO_INSPECCION=?";
		this.jdbcTemplate.update(query, 1, resultadosinspeccion.getUsuarioRegistro(),
				resultadosinspeccion.getIdResultadoInspeccion());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<ResultadosInspeccion> getMultiple(ResultadosInspeccion filterResultadosInspeccion,
			TableRequestDto tableRequestDto, Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterResultadosInspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, ResultadosInspeccion.class,
				params, "ID_RESULTADO_INSPECCION");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the ResultadosInspeccion table.
	 *
	 * @param resultadosinspeccion
	 *            ResultadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<ResultadosInspeccion>
	 */
	@Transactional(readOnly = true)
	public List<ResultadosInspeccion> findAll(ResultadosInspeccion resultadosinspeccion,
			TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_RESULTADO_INSPECCION IDRESULTADOINSPECCION,t1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t2.ID_DES_RES_INS IDDESRESINS,t2.DESCRIPCION_CASTELLANO RESULDESCRIPCIONCASTELLANO, t2.DESCRIPCION_EUSKERA RESULDESCRIPCIONEUSKERA ");
		query.append("FROM RESULTADOS_INSPECCION t1, DES_RES_INS t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(resultadosinspeccion);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_DES_RES_INS = t2.ID_DES_RES_INS ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					ResultadosInspeccionDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the ResultadosInspeccion table using like.
	 *
	 * @param resultadosinspeccion
	 *            ResultadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ResultadosInspeccion>
	 */
	@Transactional(readOnly = true)
	public List<ResultadosInspeccion> findAllLike(ResultadosInspeccion resultadosinspeccion,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_RESULTADO_INSPECCION IDRESULTADOINSPECCION,t1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t2.ID_ORIGEN_INSPECCION IDORIGEN, t2.DESCRIPCION_EUSKERA DESNEUSORIGEN, t2.DESCRIPCION_CASTELLANO DESNESORIGEN, t3.ID_DIRECCION IDDIRECCION, t3.DESCRIPCION_EUSKERA DESNEUSDIREC, t3.DESCRIPCION_CASTELLANO DESNESDIREC, t4.ID_DES_RES_INS IDDESRESINS, t4.DESCRIPCION_CASTELLANO RESULDESCRIPCIONCASTELLANO, t4.DESCRIPCION_EUSKERA RESULDESCRIPCIONEUSKERA ");
		query.append("FROM RESULTADOS_INSPECCION t1, ORIGENES_INSPECCION t2, DIRECCIONES t3, DES_RES_INS t4 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMapFindAll(resultadosinspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					ResultadosInspeccionDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMapFindAll, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the ResultadosInspeccion table.
	 *
	 * @param resultadosinspeccion
	 *            ResultadosInspeccion
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(ResultadosInspeccion resultadosinspeccion) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM RESULTADOS_INSPECCION t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(resultadosinspeccion);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the ResultadosInspeccion table using like.
	 *
	 * @param resultadosinspeccion
	 *            ResultadosInspeccion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(ResultadosInspeccion resultadosinspeccion, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT COUNT(1) FROM RESULTADOS_INSPECCION t1, ORIGENES_INSPECCION t2, DIRECCIONES t3, DES_RES_INS t4 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMapFindAll(resultadosinspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of ResultadosInspeccion selected for rup_table
	 *
	 * @param resultadosinspeccion
	 *            ResultadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ResultadosInspeccion>>
	 */
	@Override
	public List<TableRowDto<ResultadosInspeccion>> reorderSelection(ResultadosInspeccion resultadosinspeccion,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESULTADO_INSPECCION IDRESULTADOINSPECCION,t1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM RESULTADOS_INSPECCION t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(resultadosinspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto,
				ResultadosInspeccion.class, filterParamList, "ID_RESULTADO_INSPECCION");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<ResultadosInspeccion>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            ResultadosInspeccion
	 * @param searchParams
	 *            ResultadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ResultadosInspeccion>>
	 */
	@Override
	public List<TableRowDto<ResultadosInspeccion>> search(ResultadosInspeccion filterParams,
			ResultadosInspeccion searchParams, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESULTADO_INSPECCION IDRESULTADOINSPECCION,t1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM RESULTADOS_INSPECCION t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto,
				ResultadosInspeccion.class, filterParamList, searchSQL, searchParamList, from_alias,
				"ID_RESULTADO_INSPECCION");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<ResultadosInspeccion>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterresultadosinspeccion
	 *            ResultadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(ResultadosInspeccion filterresultadosinspeccion, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESULTADO_INSPECCION IDRESULTADOINSPECCION,t1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM RESULTADOS_INSPECCION t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterresultadosinspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto,
				ResultadosInspeccion.class, query, params, "ID_RESULTADO_INSPECCION");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical ResultadosInspeccion table.
	 *
	 * @param filterResultadosInspeccion
	 *            ResultadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<ResultadosInspeccion>>
	 */
	@Override
	public List<JerarquiaDto<ResultadosInspeccion>> findAllLikeJerarquia(
			ResultadosInspeccion filterResultadosInspeccion, TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESULTADO_INSPECCION IDRESULTADOINSPECCION,t1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM RESULTADOS_INSPECCION t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("RESULTADOS_INSPECCION");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterResultadosInspeccion, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_RESULTADO_INSPECCION", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					ResultadosInspeccionDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterResultadosInspeccion
	 *            ResultadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(ResultadosInspeccion filterResultadosInspeccion,
			TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM RESULTADOS_INSPECCION t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("RESULTADOS_INSPECCION");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterResultadosInspeccion, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_RESULTADO_INSPECCION",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterResultadosInspeccion
	 *            ResultadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<ResultadosInspeccion>>
	 */
	@Override
	public List<TableRowDto<ResultadosInspeccion>> findAllChild(ResultadosInspeccion filterResultadosInspeccion,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM RESULTADOS_INSPECCION t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("RESULTADOS_INSPECCION");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterResultadosInspeccion, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
				"ID_RESULTADO_INSPECCION", "ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<ResultadosInspeccion>(this.rwMapPK, "ID_RESULTADO_INSPECCION"),
				params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the ResultadosInspeccion entity
	 *
	 * @param resultadosinspeccion
	 *            ResultadosInspeccion Bean with the criteria values to filter
	 *            by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(ResultadosInspeccion resultadosinspeccion) {

		StringBuilder where = new StringBuilder(ResultadosInspeccionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (resultadosinspeccion != null && resultadosinspeccion.getIdResultadoInspeccion() != null) {
			where.append(" AND t1.ID_RESULTADO_INSPECCION = ?");
			params.add(resultadosinspeccion.getIdResultadoInspeccion());
		}
		if (resultadosinspeccion != null && resultadosinspeccion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(resultadosinspeccion.getFechaRegistro());
		}
		if (resultadosinspeccion != null && resultadosinspeccion.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(resultadosinspeccion.getUsuarioRegistro());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	private Map<String, ?> getWhereMapDatosBasicos(ResultadosInspeccion resultadosinspeccion) {

		StringBuilder where = new StringBuilder(ResultadosInspeccionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (resultadosinspeccion != null && resultadosinspeccion.getIdResultadoInspeccion() != null) {
			where.append(" AND t1.ID_RESULTADO_INSPECCION = ?");
			params.add(resultadosinspeccion.getIdResultadoInspeccion());
		}
		if (resultadosinspeccion != null && resultadosinspeccion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(resultadosinspeccion.getFechaRegistro());
		}
		if (resultadosinspeccion != null && resultadosinspeccion.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(resultadosinspeccion.getUsuarioRegistro());
		}

		where.append(
				" AND (t1.BAJA = 0 OR t1.BAJA IS NULL) AND t1.ID_DIRECCION = t2.ID_DIRECCION AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DES_RES_INS = t3.ID_DES_RES_INS AND t2.ID_INSPECCION = "
						+ resultadosinspeccion.getIdInspeccion());

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	private Map<String, ?> getWhereMapFindAll(ResultadosInspeccion resultadosinspeccion, Boolean startsWith) {

		StringBuilder where = new StringBuilder(ResultadosInspeccionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		where.append(
				" AND (t1.BAJA = 0 OR t1.BAJA IS NULL) AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION AND t1.ID_DES_RES_INS = t4.ID_DES_RES_INS ");

		if (resultadosinspeccion != null && resultadosinspeccion.getIdResultadoInspeccion() != null) {
			where.append(" AND t1.ID_RESULTADO_INSPECCION = ?");
			params.add(resultadosinspeccion.getIdResultadoInspeccion());
		}
		if (resultadosinspeccion != null && resultadosinspeccion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(resultadosinspeccion.getFechaRegistro());
		}
		if (resultadosinspeccion != null && resultadosinspeccion.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(resultadosinspeccion.getUsuarioRegistro());
		}
		if (resultadosinspeccion != null && resultadosinspeccion.getDireccion() != null
				&& resultadosinspeccion.getDireccion().getIdDireccion() != null) {
			where.append(" AND t1.ID_DIRECCION = ?");
			params.add(resultadosinspeccion.getDireccion().getIdDireccion());
		}
		if (resultadosinspeccion != null && resultadosinspeccion.getDesResIns() != null
				&& resultadosinspeccion.getDesResIns().getIdDesResIns() != null) {
			where.append(" AND t1.ID_DES_RES_INS = ?");
			params.add(resultadosinspeccion.getDesResIns().getIdDesResIns());
		}
		if (resultadosinspeccion != null && resultadosinspeccion.getOrigenInspeccion() != null
				&& resultadosinspeccion.getOrigenInspeccion().getIdOrigenInspeccion() != null) {
			where.append(" AND t1.ID_ORIGEN_INSPECCION = ?");
			params.add(resultadosinspeccion.getOrigenInspeccion().getIdOrigenInspeccion());
		}
		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the ResultadosInspeccion entity
	 *
	 * @param resultadosinspeccion
	 *            ResultadosInspeccion Bean with the criteria values to filter
	 *            by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(ResultadosInspeccion resultadosinspeccion, Boolean startsWith) {

		StringBuilder where = new StringBuilder(ResultadosInspeccionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (resultadosinspeccion != null && resultadosinspeccion.getIdResultadoInspeccion() != null) {
			where.append(" AND t1.ID_RESULTADO_INSPECCION = ?");
			params.add(resultadosinspeccion.getIdResultadoInspeccion());
		}
		if (resultadosinspeccion != null && resultadosinspeccion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(resultadosinspeccion.getFechaRegistro());
		}
		if (resultadosinspeccion != null && resultadosinspeccion.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(resultadosinspeccion.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + resultadosinspeccion.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

	/**
	 * Finds a single row in the EstadosInspeccion table.
	 *
	 * @param estadosinspeccion
	 *            EstadosInspeccion
	 * @return EstadosInspeccion
	 */
	@Transactional(readOnly = true)
	public ResultadosInspeccion findDatosBasicos(ResultadosInspeccion resultadosinspeccion) {
		String query = "SELECT t1.ID_RESULTADO_INSPECCION IDRESULTADOINSPECCION, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t2.ID_DES_RES_INS IDDESRESINS, t2.DESCRIPCION_CASTELLANO RESULDESCRIPCIONCASTELLANO, t2.DESCRIPCION_EUSKERA RESULDESCRIPCIONEUSKERA FROM RESULTADOS_INSPECCION t1, DES_RES_INS t2 WHERE t1.ID_RESULTADO_INSPECCION = ? AND t1.ID_DES_RES_INS = t2.ID_DES_RES_INS ";

		List<ResultadosInspeccion> resultadosinspeccionList = this.jdbcTemplate.query(query, this.rwMap,
				resultadosinspeccion.getIdResultadoInspeccion());
		return (ResultadosInspeccion) DataAccessUtils.uniqueResult(resultadosinspeccionList);
	}

	@Override
	public List<ResultadosInspeccion> findAllDatosInspeccion(ResultadosInspeccion resultadosInspeccion,
			TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_RESULTADO_INSPECCION IDRESULTADOINSPECCION,t1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t3.ID_DES_RES_INS IDDESRESINS, t3.DESCRIPCION_CASTELLANO RESULDESCRIPCIONCASTELLANO, t3.DESCRIPCION_EUSKERA RESULDESCRIPCIONEUSKERA ");
		query.append("FROM RESULTADOS_INSPECCION t1, INSPECCIONES t2, DES_RES_INS t3 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMapDatosBasicos(resultadosInspeccion);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					EstadosInspeccionDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<ResultadosInspeccion>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}
}
